const form = document.getElementById("form");
form.addEventListener('submit',  formHandler);

const form_status = document.getElementById("formStatus");

const button = document.getElementById("button");
button.addEventListener('submit', formHandler);

async function formHandler(listener) {
    listener.preventDefault();
    //HTML below taken from the W3 schools tutorial ()
    form_status.innerHTML = "<div class='loader'></div>"

    const formData = new FormData(form);
    const email = formData.get("email");
    const body = {email: email};


    let url = 'https://api.account.skynet.ie/ldap/new/email';
    let req;

    try {
        req = await fetch(url, {
            method: 'POST',
            body: JSON.stringify(body),
            mode: "cors"
        });
    } catch (e) {
        form_status.innerHTML = `<span style='background-color: red; color: white'>${e}</span>`;
        return;
    }

    if (req.status !== 200) {
        form_status.innerHTML = "<span style='background-color: red; color: white'>Failure</span>";
        return;
    }

    let temp = await req.json();
    if (temp.result === 'error') {
        form_status.innerHTML = `<span style='background-color: red; color: white'>${temp.error}</span>`;
    } else {
        form_status.innerHTML = "<span style='background-color: green; color: white'>Success</span>";
    }

}